#HOMELAND MOD

from CvPythonExtensions import *
#import CvUtil
#import BugUtil

from HomelandUtil import *
import StateManager as sm

# globals
gc = CyGlobalContext()
#TODO
sProvinceModule = "Europe"

def getPlotProvince( pPlot ):
	props = getPlotProperties( pPlot )
	if "province" in props :
		return props["province"]
	else :
		return None

def getPlotStartingCiv( pPlot ):
	props = getPlotProperties( pPlot )
	if "start" in props :
		return props["start"]
	else :
		return None

def getCiv( lpCities ):
	# returns the type string of the civ
	return sm.getCiv( sProvinceModule, getPlotProvince( lpCities[0].plot() ), lpCities )

def getPlotCivName( iPlayer ):
	# returns [desc, shortDesc, adjective]
	
	### TODO use Units
	pPlayer = gc.getPlayer(iPlayer)
	# if the player has a capital, name him by the region of his capital
	if( not pPlayer.getCapitalCity() == None and not pPlayer.getCapitalCity().isNone() ) :
		pPlot = pPlayer.getCapitalCity().plot()
		result = sm.getPlayerName( sProvinceModule, getPlotProvince( pPlot ), iPlayer )
		if not ( result == None ) :
			return result
	# finally, no unused name found:
	return [pPlayer.getCivilizationDescription(0), pPlayer.getCivilizationShortDescription(0), pPlayer.getCivilizationAdjective(0)]

#def getPlotCivName( iPlayer ):
#	### TODO use Units
#	### TODO: better system for avoiding double names.
#	pPlayer = gc.getPlayer(iPlayer)
#	# if the player has a capital, name him by the region of his capital
#	if( not pPlayer.getCapitalCity() == None and not pPlayer.getCapitalCity().isNone() ) :
#		pPlot = pPlayer.getCapitalCity().plot()
#		props = getPlotProperties( pPlot )
#		# has this region a name?
#		if( ("civ_desc" in props) and ("civ_shortDesc" in props) and ("civ_adjective" in props) ) :
#			name = [props["civ_desc"], props["civ_shortDesc"], props["civ_adjective"]]
#			
#			# check if name is already used
#			nameUsed = False
#			
#			for iLoopPlayer in usedNames :
#				# if iLoopPlayer isn't alive, he seems not to need the name anymore...
#				if not gc.getPlayer(iLoopPlayer).isAlive():
#					usedNames[iLoopPlayer] = None
#				
#				if usedNames[iLoopPlayer] == name :
#					nameUsed = True
#					break
#			
#			if( not nameUsed ) :
#				usedNames[iPlayer] = name
#				return name
#	
#	# finally, no unused name found:
#	return [pPlayer.getCivilizationDescription(0), pPlayer.getCivilizationShortDescription(0), pPlayer.getCivilizationAdjective(0)]
