## Starcraft Mod Specialized Python Functions
## Made by Gerikes

import CvUtil
from CvPythonExtensions import *
import BugUtil
import Homeland

# globals
gc = CyGlobalContext()

def setupPlayerStartings() :
	#messages = ["SETUP PLAYER STARTINGS"]
	for iPlotIndex in range( gc.getMap().numPlots() ):
		pPlot = gc.getMap().plotByIndex( iPlotIndex )
		plotStartingCiv = Homeland.getPlotStartingCiv( pPlot )
		if( not plotStartingCiv == None ) :
			#messages.append( "Found Starting Plot:%s"%( Homeland.getPlotStartingCiv( pPlot ) ) )
			CvUtil.pyPrint( "HRS - Found Starting Plot:%s"%( plotStartingCiv ) )
			civType = gc.getInfoTypeForString( plotStartingCiv )
			for i in range(0,gc.getMAX_CIV_PLAYERS()) :
				if( civType == gc.getPlayer(i).getCivilizationType() ) :
					pPlot.setStartingPlot( True )
					gc.getPlayer( i ).setStartingPlot( pPlot, True )
					#messages.append( "Set Starting Plot: Player #%d"%( i ) )
					CvUtil.pyPrint( "HRS - Set Starting Plot: Player #%d to starting point of %s"%( i, plotStartingCiv ) )
					break
	